Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 565776 - [science overlay] virtual/blas installed but no blas implementation available
Summary: [science overlay] virtual/blas installed but no blas implementation available
Status: RESOLVED FIXED
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: [OLD] Development (show other bugs)
Hardware: All Linux
: Normal normal (vote)
Assignee: Gentoo Science Related Packages
URL:
Whiteboard:
Keywords:
Depends on:
Blocks:
 
Reported: 2015-11-14 17:53 UTC by Dennis Schridde
Modified: 2019-07-03 12:33 UTC (History)
0 users

See Also:
Package list:
Runtime testing required: ---


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Dennis Schridde 2015-11-14 17:53:46 UTC
I do have virtual/blas installed:
```
$ eix -e virtual/blas
[I] virtual/blas
     Available versions:  [m]1.0 (~)2.1-r1[1] (~)2.1-r2[1] (~)2.1-r3[1] {doc int64}
     Installed versions:  2.1-r3[1](14:46:37 31/10/15)(-doc -int64)
     Description:         Virtual for FORTRAN 77 BLAS implementation

[1] "science" /var/lib/layman/science
```

But there is no implementation available:
```
$ eselect blas list
Available providers for blas:
  (none found)
```

My suspicion is that this is caused by dev-cpp/eigen providing it:
```
$ eix -e dev-cpp/eigen
[I] dev-cpp/eigen
     Available versions:  
     (2)    2.0.17^t
     (3)    3.1.3 (~)3.2.2[1] (~)3.2.4[1] (~)3.2.5 (~)3.2.6 **9999[1]
       {adolc debug doc examples fftw fortran gmp metis mkl pastix sparse static-libs test}
     Installed versions:  2.0.17(2)^t(12:18:03 23/06/15)(-debug -doc -examples) 3.2.6(3)(14:42:37 31/10/15)(-debug -doc)
     Homepage:            http://eigen.tuxfamily.org/
     Description:         C++ template library for linear algebra

[1] "science" /var/lib/layman/science
```

/var/lib/layman/science/virtual/blas/blas-2.1-r3.ebuild: RDEPEND="|| ( ... >=dev-cpp/eigen-3.1.4 ... )"

I know that Eigen 3 comes with a BLAS and partial LAPACK implementation, but something seems to be missing in Gentoo, preventing it from being detected as a proper alternative...

Sidenote: The version of Eigen provided in the Science overlay is pretty outdated.

Reproducible: Always




$ emerge --info
Portage 2.2.24 (python 3.4.3-final-0, default/linux/amd64/13.0/desktop/plasma/systemd, gcc-4.9.3, glibc-2.22-r1, 4.3.0-gentoo x86_64)
=================================================================
System uname: Linux-4.3.0-gentoo-x86_64-AMD_A10-7800_Radeon_R7,_12_Compute_Cores_4C+8G-with-gentoo-2.2
KiB Mem:    15381504 total,   1113584 free
KiB Swap:          0 total,         0 free
Timestamp of repository gentoo: Sat, 14 Nov 2015 09:15:01 +0000
sh bash 4.3_p42
ld GNU ld (Gentoo 2.25 p1.2) 2.25
ccache version 3.2.4 [disabled]
app-shells/bash:          4.3_p42::gentoo
dev-java/java-config:     2.2.0::gentoo
dev-lang/perl:            5.22.0::gentoo
dev-lang/python:          2.7.10-r2::gentoo, 3.4.3-r2::gentoo
dev-util/ccache:          3.2.4::gentoo
dev-util/cmake:           3.4.0::gentoo
dev-util/pkgconfig:       0.29::gentoo
sys-apps/baselayout:      2.2::gentoo
sys-apps/sandbox:         2.9::gentoo
sys-devel/autoconf:       2.13::gentoo, 2.69-r1::gentoo
sys-devel/automake:       1.11.6-r1::gentoo, 1.12.6::gentoo, 1.13.4::gentoo, 1.14.1::gentoo, 1.15::gentoo
sys-devel/binutils:       2.25-r1::gentoo
sys-devel/gcc:            4.9.3::gentoo
sys-devel/gcc-config:     1.8-r1::gentoo
sys-devel/libtool:        2.4.6-r1::gentoo
sys-devel/make:           4.1-r1::gentoo
sys-kernel/linux-headers: 4.3::gentoo (virtual/os-headers)
sys-libs/glibc:           2.22-r1::gentoo
Repositories:

gentoo
    location: /var/cache/portage/gentoo
    sync-type: rsync
    sync-uri: rsync://rsync.de.gentoo.org/gentoo-portage
    priority: -1000

aegypius
    location: /var/lib/layman/aegypius
    sync-type: laymansync
    sync-uri: git://github.com/aegypius/overlay.git
    masters: gentoo
    priority: 50

kde
    location: /var/lib/layman/kde
    sync-type: laymansync
    sync-uri: git://anongit.gentoo.org/proj/kde.git
    masters: gentoo
    priority: 50

sage-on-gentoo
    location: /var/lib/layman/sage-on-gentoo
    sync-type: laymansync
    sync-uri: git://github.com/cschwan/sage-on-gentoo.git
    masters: gentoo science
    priority: 50

science
    location: /var/lib/layman/science
    sync-type: laymansync
    sync-uri: git://anongit.gentoo.org/proj/sci.git
    masters: gentoo
    priority: 50

local
    location: /var/cache/portage/local
    masters: gentoo
    priority: 100

ACCEPT_KEYWORDS="amd64 ~amd64"
ACCEPT_LICENSE="* -@EULA"
CBUILD="x86_64-pc-linux-gnu"
CFLAGS="-pipe -O2 -march=bdver3"
CHOST="x86_64-pc-linux-gnu"
CONFIG_PROTECT="/etc /usr/lib64/libreoffice/program/sofficerc /usr/share/config /usr/share/gnupg/qualified.txt /usr/share/themes/oxygen-gtk/gtk-2.0 /usr/share/themes/oxygen-gtk/gtk-3.0"
CONFIG_PROTECT_MASK="/etc/ca-certificates.conf /etc/dconf /etc/env.d /etc/fonts/fonts.conf /etc/gconf /etc/gentoo-release /etc/php/apache2-php5.6/ext-active/ /etc/php/cgi-php5.6/ext-active/ /etc/php/cli-php5.6/ext-active/ /etc/revdep-rebuild /etc/sandbox.d /etc/terminfo /etc/texmf/language.dat.d /etc/texmf/language.def.d /etc/texmf/updmap.d /etc/texmf/web2c"
CXXFLAGS="-pipe -O2 -march=bdver3"
DISTDIR="/var/cache/portage/distfiles"
EMERGE_DEFAULT_OPTS="--keep-going --nospinner"
FCFLAGS="-O2 -pipe"
FEATURES="assume-digests binpkg-logs buildsyspkg compressdebug config-protect-if-modified distlocks ebuild-locks fixlafiles merge-sync news parallel-fetch parallel-install preserve-libs protect-owned sandbox sfperms strict unknown-features-warn unmerge-logs unmerge-orphans userfetch userpriv usersandbox usersync xattr"
FFLAGS="-O2 -pipe"
GENTOO_MIRRORS="http://ftp.spline.inf.fu-berlin.de/mirrors/gentoo/ http://ftp-stud.hs-esslingen.de/pub/Mirrors/gentoo/ http://distfiles.gentoo.org"
LANG="en_GB.UTF-8"
LDFLAGS="-Wl,-O1 -Wl,--as-needed -Wl,--hash-style=gnu"
MAKEOPTS="-j5"
PKGDIR="/var/cache/portage/packages"
PORTAGE_COMPRESS="xz"
PORTAGE_CONFIGROOT="/"
PORTAGE_RSYNC_OPTS="--recursive --links --safe-links --perms --times --omit-dir-times --compress --force --whole-file --delete --stats --human-readable --timeout=180 --exclude=/distfiles --exclude=/local --exclude=/packages"
PORTAGE_TMPDIR="/var/tmp"
USE="X a52 aac aacplus aacs acl acpi alsa amd64 appindicator audit avahi bash-completion bdplus berkdb bluetooth bluray branding bzip2 cairo caps cdda cddb cdio cdr celt cjk cli conntrack cracklib crypt cups cxx dbus declarative dirac dri dts dvb dvd dvdr egl emboss encode exif fam fax ffmpeg firefox flac fontconfig fortran gdbm gif glamor gles gles2 gmp gpm gstreamer gtk ibus iconv ipv6 jpeg jpeg2k kde kipi ladspa latex lcms ldap libinput libnotify libproxy libsecret lua_target_lua5-2 lv2 lz4 lzma lzo mad mmx mmxext mng modemmanager modplug modules mp3 mp4 mpeg mplayer mtp multilib multitarget mysql ncurses netlink networkmanager nls nptl ogg openal opencl openexr opengl openmax openmp opus pam pango pch pcre pdf phonon plasma png policykit ppds pulseaudio qml qt3support qt4 qt5 readline rtmp samba scanner schroedinger sctp sdl seccomp semantic-desktop session speex spell sse sse2 ssl startup-notification subversion svg systemd tcpd theora threads tiff truetype udev udisks unicode upnp upnp-av upower usb v4l vaapi vdpau vorbis vpx wavpack wayland webp widgets x264 x265 xattr xcb xcomposite xinerama xml xrandr xscreensaver xv xvid xz zeroconf zlib" ABI_X86="64" ALSA_CARDS="hda-intel" APACHE2_MODULES="authn_core authz_core socache_shmcb unixd actions alias auth_basic authn_alias authn_anon authn_dbm authn_default authn_file authz_dbm authz_default authz_groupfile authz_host authz_owner authz_user autoindex cache cgi cgid dav dav_fs dav_lock deflate dir disk_cache env expires ext_filter file_cache filter headers include info log_config logio mem_cache mime mime_magic negotiation rewrite setenvif speling status unique_id userdir usertrack vhost_alias" CALLIGRA_FEATURES="stage words flow sheets gemini" CAMERAS="ptp2" COLLECTD_PLUGINS="df interface irq load memory rrdtool swap syslog" CPU_FLAGS_X86="3dnow 3dnowext mmx mmxext sse sse2 sse3" DRACUT_MODULES="btrfs caps systemd" ELIBC="glibc" ENLIGHTENMENT_MODULES="*" GPSD_PROTOCOLS="ashtech aivdm earthmate evermore fv18 garmin garmintxt gpsclock itrax mtk3301 nmea ntrip navcom oceanserver oldstyle oncore rtcm104v2 rtcm104v3 sirf superstar2 timing tsip tripmate tnt ublox ubx" GRUB_PLATFORMS="coreboot efi-64 pc" INPUT_DEVICES="evdev joystick" KERNEL="linux" LCD_DEVICES="bayrad cfontz cfontz633 glk hd44780 lb216 lcdm001 mtxorb ncurses text" LIBREOFFICE_EXTENSIONS="presenter-console presenter-minimizer" LINGUAS="de en en_GB ar fa" LIRC_DEVICES="devinput" OFFICE_IMPLEMENTATION="libreoffice" PHP_TARGETS="php5-5" PYTHON_SINGLE_TARGET="python2_7" PYTHON_TARGETS="python2_7 python3_4" RUBY_TARGETS="ruby20 ruby21" USERLAND="GNU" VIDEO_CARDS="amdgpu radeon radeonsi" XTABLES_ADDONS="quota2 psd pknock lscan length2 ipv4options ipset ipp2p iface geoip fuzzy condition tee tarpit sysrq steal rawnat logmark ipmark dhcpmac delude chaos account"
Unset:  CC, CPPFLAGS, CTARGET, CXX, INSTALL_MASK, LC_ALL, PORTAGE_BUNZIP2_COMMAND, PORTAGE_COMPRESS_FLAGS, PORTAGE_RSYNC_EXTRA_OPTS, USE_PYTHON
Comment 1 Justin Lecher gentoo-dev 2015-11-20 09:26:48 UTC
The in tree version doesn't support blas through eselect. Someone needs to bump it in the sci overlay.
Comment 2 Dennis Schridde 2015-11-21 16:43:30 UTC
(In reply to Justin Lecher from comment #1)
> The in tree version doesn't support blas through eselect. Someone needs to
> bump it in the sci overlay.

The version can be bumped by copying and making the changes outlined below the diff below.

I also had a look at the changes of the dev-cpp/eigen ebuild in the Gentoo tree:
```diff
--- eigen-3.2.4.ebuild.1        2015-11-21 11:45:20.440434812 +0100
+++ /var/cache/portage/gentoo/dev-cpp/eigen/eigen-3.2.6.ebuild  2015-10-27 15:31:02.000000000 +0100
@@ -8,7 +8,7 @@
 
 DESCRIPTION="C++ template library for linear algebra: vectors, matrices, and related algorithms"
 HOMEPAGE="http://eigen.tuxfamily.org/"
-SRC_URI="http://bitbucket.org/eigen/eigen/get/${PV}.tar.bz2 -> ${P}.tar.bz2"
+SRC_URI="https://bitbucket.org/eigen/eigen/get/${PV}.tar.bz2 -> ${P}.tar.bz2"
 
 LICENSE="LGPL-2 GPL-3"
 SLOT="3"
@@ -30,12 +30,9 @@
                -e "/add_subdirectory(lapack/d" \
                || die "sed disable unused bundles failed"
 
-       cmake-utils_src_prepare
-}
+       sed -i -e "/Unknown build type/d" CMakeLists.txt || die
 
-src_configure() {
-       CMAKE_BUILD_TYPE="release"
-       cmake-utils_src_configure
+       cmake-utils_src_prepare
 }
 
 src_compile() {
@@ -59,7 +56,10 @@
 src_install() {
        cmake-utils_src_install
        if use doc; then
-               cd "${BUILD_DIR}"/doc
-               dohtml -r html/*
+               dohtml -r "${BUILD_DIR}"/doc/html/*
        fi
+
+       # Debian installs it and some projects started using it.
+       insinto /usr/share/cmake/Modules/
+       doins "${S}/cmake/FindEigen3.cmake"
 }
```

The "/Unknown build type/d" sed does not seem to be necessary (it builds here without), but someone more familiar with Eigen should have a look at this.

The 3 lines related to FindEigen3.cmake need to be added.
Comment 3 Larry the Git Cow gentoo-dev 2019-06-26 06:06:42 UTC
The bug has been closed via the following commit(s):

https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=5f8a985b71b033d7a7c4d252c00dd83669ee5913

commit 5f8a985b71b033d7a7c4d252c00dd83669ee5913
Author:     Mo Zhou <cdluminate@gmail.com>
AuthorDate: 2019-06-26 02:27:40 +0000
Commit:     Benda Xu <heroxbd@gentoo.org>
CommitDate: 2019-06-26 06:06:09 +0000

    virtual/{blas,cblas,lapack,lapacke}: add/update virtual packages.
    
      These virtual packages are used by the BLAS/LAPACK runtime switching
      mechanism.
    
      Drop old EAPI=5 ebuilds.
    
    Closes: https://github.com/gentoo/gentoo/pull/12323
    Closes: https://bugs.gentoo.org/373613
    Closes: https://bugs.gentoo.org/669644
    Closes: https://bugs.gentoo.org/564546
    Closes: https://bugs.gentoo.org/565776
    Closes: https://bugs.gentoo.org/646316
    Closes: https://bugs.gentoo.org/563674
    Closes: https://bugs.gentoo.org/659014
    Closes: https://bugs.gentoo.org/659264
    Closes: https://bugs.gentoo.org/657984
    Closes: https://bugs.gentoo.org/381801
    Closes: https://bugs.gentoo.org/646316
    Closes: https://bugs.gentoo.org/565776
    Closes: https://bugs.gentoo.org/498490
    
    Signed-off-by: Mo Zhou <cdluminate@gmail.com>
    Signed-off-by: Benda Xu <heroxbd@gentoo.org>

 virtual/blas/blas-1.0.ebuild       | 14 --------------
 virtual/blas/blas-3.8.ebuild       | 14 ++++++++++++++
 virtual/blas/metadata.xml          | 10 +++++++---
 virtual/cblas/cblas-1.0.ebuild     | 14 --------------
 virtual/cblas/cblas-3.8.ebuild     | 14 ++++++++++++++
 virtual/cblas/metadata.xml         | 10 +++++++---
 virtual/lapack/lapack-3.0.ebuild   | 13 -------------
 virtual/lapack/lapack-3.1.ebuild   | 13 -------------
 virtual/lapack/lapack-3.8.ebuild   | 14 ++++++++++++++
 virtual/lapack/metadata.xml        | 10 +++++++---
 virtual/lapacke/lapacke-3.8.ebuild | 14 ++++++++++++++
 virtual/lapacke/metadata.xml       | 16 ++++++++++++++++
 12 files changed, 93 insertions(+), 63 deletions(-)

https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=5f8a985b71b033d7a7c4d252c00dd83669ee5913

commit 5f8a985b71b033d7a7c4d252c00dd83669ee5913
Author:     Mo Zhou <cdluminate@gmail.com>
AuthorDate: 2019-06-26 02:27:40 +0000
Commit:     Benda Xu <heroxbd@gentoo.org>
CommitDate: 2019-06-26 06:06:09 +0000

    virtual/{blas,cblas,lapack,lapacke}: add/update virtual packages.
    
      These virtual packages are used by the BLAS/LAPACK runtime switching
      mechanism.
    
      Drop old EAPI=5 ebuilds.
    
    Closes: https://github.com/gentoo/gentoo/pull/12323
    Closes: https://bugs.gentoo.org/373613
    Closes: https://bugs.gentoo.org/669644
    Closes: https://bugs.gentoo.org/564546
    Closes: https://bugs.gentoo.org/565776
    Closes: https://bugs.gentoo.org/646316
    Closes: https://bugs.gentoo.org/563674
    Closes: https://bugs.gentoo.org/659014
    Closes: https://bugs.gentoo.org/659264
    Closes: https://bugs.gentoo.org/657984
    Closes: https://bugs.gentoo.org/381801
    Closes: https://bugs.gentoo.org/646316
    Closes: https://bugs.gentoo.org/565776
    Closes: https://bugs.gentoo.org/498490
    
    Signed-off-by: Mo Zhou <cdluminate@gmail.com>
    Signed-off-by: Benda Xu <heroxbd@gentoo.org>

 virtual/blas/blas-1.0.ebuild       | 14 --------------
 virtual/blas/blas-3.8.ebuild       | 14 ++++++++++++++
 virtual/blas/metadata.xml          | 10 +++++++---
 virtual/cblas/cblas-1.0.ebuild     | 14 --------------
 virtual/cblas/cblas-3.8.ebuild     | 14 ++++++++++++++
 virtual/cblas/metadata.xml         | 10 +++++++---
 virtual/lapack/lapack-3.0.ebuild   | 13 -------------
 virtual/lapack/lapack-3.1.ebuild   | 13 -------------
 virtual/lapack/lapack-3.8.ebuild   | 14 ++++++++++++++
 virtual/lapack/metadata.xml        | 10 +++++++---
 virtual/lapacke/lapacke-3.8.ebuild | 14 ++++++++++++++
 virtual/lapacke/metadata.xml       | 16 ++++++++++++++++
 12 files changed, 93 insertions(+), 63 deletions(-)
Comment 4 Larry the Git Cow gentoo-dev 2019-07-03 12:33:45 UTC
The bug has been closed via the following commit(s):

https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=0721aba4db4bc8ce37d11eab06ff528f31e4ce9f

commit 0721aba4db4bc8ce37d11eab06ff528f31e4ce9f
Author:     Benda Xu <heroxbd@gentoo.org>
AuthorDate: 2019-06-27 05:41:31 +0000
Commit:     Benda Xu <heroxbd@gentoo.org>
CommitDate: 2019-07-03 12:30:39 +0000

    virtual/{blas,cblas,lapack,lapacke}: add virtual packages.
    
      These virtual packages are used by the BLAS/LAPACK runtime switching
      mechanism.
    
    Closes: https://github.com/gentoo/gentoo/pull/12323
    Closes: https://bugs.gentoo.org/373613
    Closes: https://bugs.gentoo.org/381801
    Closes: https://bugs.gentoo.org/498490
    Closes: https://bugs.gentoo.org/563674
    Closes: https://bugs.gentoo.org/564546
    Closes: https://bugs.gentoo.org/565776
    Closes: https://bugs.gentoo.org/646316
    Closes: https://bugs.gentoo.org/657984
    Closes: https://bugs.gentoo.org/659014
    Closes: https://bugs.gentoo.org/659264
    Closes: https://bugs.gentoo.org/669644
    
    Signed-off-by: Mo Zhou <cdluminate@gmail.com>
    Signed-off-by: Benda Xu <heroxbd@gentoo.org>

 virtual/blas/blas-3.8.ebuild       | 14 ++++++++++++++
 virtual/blas/metadata.xml          | 10 +++++++---
 virtual/cblas/cblas-3.8.ebuild     | 14 ++++++++++++++
 virtual/cblas/metadata.xml         | 10 +++++++---
 virtual/lapack/lapack-3.8.ebuild   | 14 ++++++++++++++
 virtual/lapack/metadata.xml        | 10 +++++++---
 virtual/lapacke/lapacke-3.8.ebuild | 14 ++++++++++++++
 virtual/lapacke/metadata.xml       | 16 ++++++++++++++++
 8 files changed, 93 insertions(+), 9 deletions(-)